unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, rkFilterPreviewDialog, Math, ExtDlgs, Jpeg, ExtCtrls;

type
  TfrmMain = class(TForm)
    dlgPreview: TrkFilterPreviewDialog;
    dlgOpen: TOpenPictureDialog;
    imgTest: TImage;
    Panel1: TPanel;
    btnBlur: TButton;
    btnOpen: TButton;
    btnAdjColor: TButton;
    btnMisc: TButton;
    btnMisc2: TButton;
    imgShade: TImage;
    procedure btnBlurClick(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure dlgPreviewImageProcess(Sender: TObject; ABitmap: TBitmap);
    procedure dlgPreviewControlChange(Sender: TObject; AIdx, AValue: Integer);
    procedure FormCreate(Sender: TObject);
    procedure btnAdjColorClick(Sender: TObject);
    procedure btnMiscClick(Sender: TObject);
    procedure btnMisc2Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    procedure DoImageProcess(ABitmap: TBitmap);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
  rkSmartGfx;

var
  Blur: Array [0..2] of Integer;
  AdjBCS: Array[0..2] of Integer;
  FxId, AdjId, AdjExp: Integer;
  MiscId, MiscSpray, MiscLight, MiscBlur, MiscMosaic, MiscVRoll, MiscHRoll: Integer;
  Misc2Id, Misc2Color: Integer;

procedure TfrmMain.btnOpenClick(Sender: TObject);
var
  bmp: TBitmap;
begin
  if dlgOpen.Execute then
  begin
    bmp:= TBitmap.Create;
    imgTest.Picture.LoadFromFile(dlgOpen.Filename);
    bmp.Assign(imgTest.Picture.Graphic);
    bmp.PixelFormat:= pf24bit;
    imgTest.Picture.Bitmap.Assign(bmp);
    dlgPreview.Picture.Assign(imgTest.Picture.Graphic);
    bmp.Free;
  end;
end;

procedure TfrmMain.btnAdjColorClick(Sender: TObject);
begin
  dlgPreview.Picture.Assign(imgTest.Picture.Graphic);
  if dlgPreview.Picture.Width > 0 then
  begin
    FxId:= 0;
    dlgPreview.Caption:= 'Adjust color';
    dlgPreview.CtrlBegin:= 8;
    dlgPreview.CtrlEnd:= 24;
    dlgPreview.SetRadioBtn(AdjId);
    dlgPreview.SetTrackbarPos(1, AdjExp);
    dlgPreview.SetTrackbarPos(2, AdjBCS[0]);
    dlgPreview.SetTrackbarPos(3, AdjBCS[1]);
    dlgPreview.SetTrackbarPos(4, AdjBCS[2]);
    if dlgPreview.Execute then
      DoImageProcess(imgTest.Picture.Bitmap);
    imgTest.Invalidate;
  end
  else
    ShowMessage('Load a image first!');
end;

procedure TfrmMain.btnBlurClick(Sender: TObject);
begin
  dlgPreview.Picture.Assign(imgTest.Picture.Graphic);
  if dlgPreview.Picture.Width > 0 then
  begin
    FxId:= 1;
    dlgPreview.Caption:= 'BoxBlur';
    dlgPreview.CtrlBegin:= 0;
    dlgPreview.CtrlEnd:= 6;
    dlgPreview.SetTrackbarPos(1, Blur[0]);
    dlgPreview.SetTrackbarPos(2, Blur[1]);
    dlgPreview.SetTrackbarPos(3, Blur[2]);
    if dlgPreview.Execute then
      DoImageProcess(imgTest.Picture.Bitmap);
    imgTest.Invalidate;
  end
  else
    ShowMessage('Load a image first!');
end;

procedure TfrmMain.btnMisc2Click(Sender: TObject);
begin
  dlgPreview.Picture.Assign(imgTest.Picture.Graphic);
  if dlgPreview.Picture.Width > 0 then
  begin
    FxId:= 3;
    dlgPreview.Caption:= 'Misc 2';
    dlgPreview.CtrlBegin:= 42;
    dlgPreview.CtrlEnd:= 52;
    dlgPreview.SetRadioBtn(Misc2Id);
    dlgPreview.SetTrackbarPos(1, Misc2Color);
    if dlgPreview.Execute then
      DoImageProcess(imgTest.Picture.Bitmap);
    imgTest.Invalidate;
  end
  else
    ShowMessage('Load a image first!');
end;

procedure TfrmMain.btnMiscClick(Sender: TObject);
begin
  dlgPreview.Picture.Assign(imgTest.Picture.Graphic);
  if dlgPreview.Picture.Width > 0 then
  begin
    FxId:= 2;
    dlgPreview.Caption:= 'Misc';
    dlgPreview.CtrlBegin:= 26;
    dlgPreview.CtrlEnd:= 40;
    dlgPreview.SetRadioBtn(MiscId);
    dlgPreview.SetTrackbarPos(1, MiscMosaic);
    dlgPreview.SetTrackbarPos(2, MiscLight);
    dlgPreview.SetTrackbarPos(3, MiscBlur);
    dlgPreview.SetTrackbarPos(4, MiscSpray);
    dlgPreview.SetTrackbarPos(5, MiscVRoll);
    if dlgPreview.Execute then
      DoImageProcess(imgTest.Picture.Bitmap);
    imgTest.Invalidate;
  end
  else
    ShowMessage('Load a image first!');
end;

procedure TfrmMain.dlgPreviewControlChange(Sender: TObject; AIdx, AValue: Integer);
begin
  if FxId = 0 then
    case AIdx of
      1 : AdjId:= 1;
      2 : AdjId:= 2;
      3 : AdjExp:= AValue;
      4 : AdjId:= 3;
      5 : AdjBCS[0] := AValue;
      6 : AdjBCS[1] := AValue;
      7 : AdjBCS[2] := AValue;
      8 : AdjId:= 4;
      9 : AdjId:= 5;
      10: AdjId:= 6;
    else
    end;
  if FxId = 1 then
    case AIdx of
      1 : Blur[0] := AValue;
      2 : Blur[1] := AValue;
      3 : Blur[2] := AValue;
    else
    end;
  if FxId = 2 then
    case AIdx of
      1 : MiscId:= 1;
      2 : MiscMosaic:= AValue;
      3 : MiscId:= 2;
      4 : MiscLight:= AValue;
      5 : MiscId:= 3;
      6 : MiscBlur:= AValue;
      7 : MiscId:= 4;
      8 : MiscSpray:= AValue;
      9 : MiscId:= 5;
      10: MiscVRoll:= AValue;
      11: MiscHRoll:= AValue;
    else
    end;
  if FxId = 3 then
    case AIdx of
      1 : Misc2Id:= 1;
      2 : Misc2Color:= AValue;
      3 : Misc2Id:= 2;
      4 : Misc2Id:= 3;
      5 : Misc2Id:= 4;
    else
    end;
end;

procedure TfrmMain.dlgPreviewImageProcess(Sender: TObject; ABitmap: TBitmap);
begin
  DoImageProcess(ABitmap);
end;

procedure TfrmMain.DoImageProcess(ABitmap: TBitmap);
begin
  case FxId of
    0:
    begin
      case AdjId of
        1 : fxHistEqu(ABitmap, 0.3);
        2 : fxExposure(ABitmap, AdjExp);
        3 : fxBCS(ABitmap, AdjBCS[0], AdjBCS[1], AdjBCS[2]);
        4, 5, 6: fxGrayScale(ABitmap, AdjId - 4);
      else
      end;
    end;
    1: fxBoxBlur(ABitmap, blur[1], blur[2], Blur[0]);
    2:
    begin
      case MiscId of
        1 : fxMosaic(ABitmap, MiscMosaic);
        2 : fxSplitLight(ABitmap, MiscLight);
        3 : fxSplitBlur(ABitmap, MiscBlur);
        4 : fxSpray(ABitmap, MiscSpray);
        5 : fxRoll(ABitmap, Round((ABitmap.Width / 100) * MiscHRoll), Round((ABitmap.Height / 100) * MiscVRoll));
      else
      end;
    end;
    3:
    begin
      case Misc2Id of
        1 : fxSplitColor(ABitmap, Misc2Color);
        2 : fxAutoYHist(ABitmap, 1);
        3 : fxAutoContrast(ABitmap);
        4 : fxSoftFilter(ABitmap, 3);
      else
      end;
    end;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var
 bmp: Tbitmap;
begin
  Blur[0]:= 3;
  Blur[1]:= 10;
  Blur[2]:= 10;
  AdjId:= 1;
  AdjExp:= 0;
  AdjBCS[0]:= 255;
  AdjBCS[1]:= 0;
  AdjBCS[2]:= 255;
  MiscId:= 1;
  MiscMosaic:= 10;
  MiscSpray:= 10;
  MiscLight:= 1;
  MiscBlur:= 10;
  MiscVRoll:= 10;
  MiscHRoll:= 10;
  Misc2Id:= 1;
  Misc2Color:= 128;
  bmp:= TBitmap.Create;
  bmp.PixelFormat:= pf24Bit;
  bmp.Width:= ClientWidth;
  bmp.Height:= 3;
  imgShade.Picture.Bitmap.Assign(bmp);
  bmp.Free;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  imgShade.Picture.Bitmap.Width:= ClientWidth;
  ShadeGradientHorz(imgShade.Picture.Bitmap, clWindow, clGray, True, False);
end;

end.
